diff -urpN john-1.7.8-jumbo-6a/src/pkzip_fmt_plug.c john-1.7.8-jumbo-6b/src/pkzip_fmt_plug.c
--- john-1.7.8-jumbo-6a/src/pkzip_fmt_plug.c	2011-09-01 15:26:20.968750000 +0000
+++ john-1.7.8-jumbo-6b/src/pkzip_fmt_plug.c	2011-09-09 20:44:27.000000000 +0000
@@ -810,118 +890,612 @@ static int isLegalUTF8_char(const u8 *so
     if (*source > 0xF4) return -1;
     return len+1;
 }
+static u8 *buf_copy (char *p, int len) {
+	u8 *op = mem_alloc_tiny(len, MEM_ALIGN_NONE);
+	memcpy(op, p, len);
+	return op;
+}
+static int validate_ascii(const u8 *out, int inplen) {
+	int i;
+	int unicode=0, utf8=0;
 
-
-static int decomp_validate_ascii(u8 *inp, u8 *out, int inplen, int outlen) {
-
-	z_stream strm;
-	int ret, i;
-
-	if (salt->asciiCompType == 0) {
-		/* file is stored, so simply check the bytes no need to decompress */
-		for (i = 0; i < inplen-1; ++i) {
-			if (inp[i] > 0x7E)
-				return 0;
-			if (inp[i] < 0x20) {
-				/* we do not need to deal with DOS EOF char 0x1a, since we will never have the 'end' of the file */
-				if (inp[i]!='\n' && inp[i]!='\r' && inp[i]!='\t')
-					return 0;
-			}
-		}
-		return 1;
-	}
-
-	strm.zalloc = Z_NULL;
-	strm.zfree = Z_NULL;
-	strm.opaque = Z_NULL;
-	strm.avail_in = 0;
-	strm.next_in = Z_NULL;
-	
-	ret = inflateInit2(&strm, -15); /* 'raw', since we do not have gzip header, or gzip crc. .ZIP files are 'raw' implode data. */
-	if (ret != Z_OK)
-	   perror("Error, initializing the libz inflateInit2() system\n");
-
-	strm.avail_in = inplen;
-	strm.next_in = inp;
-	strm.avail_out = outlen;
-	strm.next_out = out;
-
-	ret = inflate(&strm, Z_SYNC_FLUSH);
-
-	inflateEnd(&strm);
-
-	if (ret != Z_OK || strm.total_out < 30)
-		return 0;
-
-	for (i = 0; i < strm.total_out-1; ++i) {
+	for (i = 0; i < inplen-1; ++i) {
 		if (out[i] > 0x7E) {
 			// first check to 'see' if this is a valid utf8 character.  If so, let it 'pass'.
+			if (unicode)
+				return 0; // in unicode mode, we ONLY handle 'ascii' bytes in the low byte.
+
 			if (out[i] > 0xC0) {
 				int len;
-				if(i > strm.total_out-4)
+				if(i > inplen-4)
 					return 1;
 				len = isLegalUTF8_char(&out[i], 5);
 				if (len < 0) return 0;
 				i += (len-1);
 			}
-			else if (out[i] != 0xA9)
-				return 0;
+			else {
+				if (i) {
+					// check for utf8 BOM  \xEF \xBB \xBF
+					if (out[0] == 0xEF && out[1] == 0xBB && out[2] == 0xBF) {
+						i = 2;
+						utf8 = 1;
+						continue;
+					}
+					/* check for Unicode BOM  (FF FE for utf16le, FE FF for utf16be, FF FE 00 00 for utf32le, not sure if 00 00 FE FF is utf32be, but likely is) */
+					if (out[0] == 0xFF && out[1] == 0xFE) {
+						unicode = 1;
+						i++;
+						continue;
+					}
+					/* unicode BE bom */
+					if (out[0] == 0xFE && out[1] == 0xFF) {
+						unicode = 1;
+						i += 2;
+						continue;
+					}
+					/* utf32 LE */
+					if (out[0] == 0xFF && out[1] == 0xFE && out[2] == 0 && out[3] == 0) {
+						unicode = 3;
+						i += 3;
+						continue;
+					}
+					/* utf32 BE bom */
+					if (out[0] == 0 && out[1] == 0 && out[2] == 0xFE && out[3] == 0xFF) {
+						unicode = 3;
+						i += 6;
+						continue;
+					}
+
+					// allow a 'single' byte > 0x7E as long as bytes following are ascii.
+					if (out[1] <= 0x7E && out[1] >= 0x20) {
+						++i;
+						continue;
+					}
+					return 0;
+				}
+			}
 		} else if (out[i] < 0x20) {
 			/* we do not need to deal with DOS EOF char 0x1a, since we will never have the 'end' of the file */
-			if (out[i]!='\n' && out[i]!='\r' && out[i]!='\t')
+			/* we do allow the ESC character for ANSI files, however, they are frequently also binary, so will fail in other places */
+			if (out[i]!='\n' && out[i]!='\r' && out[i]!='\t' && out[i]!=0x1B) 
 				return 0;
 		}
+		i += unicode; // skip the null bytes
 	}
+	return 1;
+}
+static int CheckSigs(const u8 *p, int len, ZIP_SIGS *pSig) {
+	int i, j;
 
-//printf ("strm.total_out=%03d  ", strm.total_out);
-#ifdef ZIP_DEBUG
-	salt->ascii_ucmp[strm.total_out-1] = 0;
-	printf ("ASCII find:  decoded to: len=%ld [%s]\n", strm.total_out, salt->ascii_ucmp);
+	for (i = 0; i < pSig->magic_count; ++i) {
+		int fnd = 1;
+		u8 *pS = pSig->magic_signature[i];
+		for (j = 0; j < pSig->magic_sig_len[i]; ++j) {
+			if (p[j] != pS[j]) {
+				fnd = 0;
+				break;
+			}
+		}
+		if (fnd)
+			return 1;
+	}
+	return 0;
+}
 #endif
-	return 1;
+
+#ifdef __GNUC__
+#if __GNUC__ > 3 || (__GNUC__ == 3 && __GNUC_MINOR__ >= 1)
+__attribute__((always_inline))
+#else
+__inline__
+#endif
+#endif
+/* note, Buf is the 'full' decrypted zip buffer (len bytes long). It DOES contain the first 3 bits, which have already 
+ * been decoded, and have told us we had a code 2 (var table block) 
+ * all done without BITS(), PULLBYTE(), BITSNEEDED() macros.  We 'know' the data we need, and we know that we have
+ * 'enough', so we do not worry about all of the overhead, and validation logic.
+ *
+ * In testing, this function catches ALL bad decryptions, except about 1/300 to 1/350. So, it is not too bad.
+ */
+static int check_inflate_CODE2(u8 *next) {
+	u32 bits, hold, thisget, have, i;
+	int left;
+	u32 ncode;
+	u32 ncount[2];	// ends up being an array of 8 u8 count values.  But we can clear it, and later 'check' it with 2 u32 instructions.
+	u8 *count;		// this will point to ncount array. NOTE, this is alignment required 'safe' for Sparc systems or others requiring alignment.
+#if (ARCH_LITTLE_ENDIAN==1) && (ARCH_ALLOWS_UNALIGNED==1)
+	// 'speedup' for x86 type systems.  pkzip/inflate was designed here, so why not use it.
+	hold = *((u32*)next);
+#else
+	hold = *next + (((u32*)next[1])<<8) + (((u32*)next[2])<<16) + (((u32*)next[3])<<24);
+#endif
+	next += 3;	// we pre-increment when pulling it in the loop, thus we need to be 1 byte back.
+	hold >>= 3;	// we already processed 3 bits
+	count = (u8*)ncount;
+
+	if (257+(hold&0x1F) > 286) return 0;	// nlen, but we do not use it.
+	hold >>= 5;
+	if(1+(hold&0x1F) > 30) return 0;		// ndist, but we do not use it.
+	hold >>= 5;
+    ncode = 4+(hold&0xF);
+	hold >>= 4;
+
+	// we have 15 bits left.
+	hold += ((u32)(*++next)) << 15;
+	hold += ((u32)(*++next)) << 23;
+	// we now have 31 bits.  We need to know this for the loop below.  
+	bits = 31;
+
+	// We have 31 bits now, in accum.  If we are processing 19 codes, we do 7, then have 10 bits.  
+	// Add 16 more and have 26, then use 21, have 5.  Then load 16 more, then eat 15 of them.
+	have = 0;
+
+	ncount[0] = ncount[1] = 0;
+	for (;;) {
+		if (have+7>ncode)
+			thisget = ncode-have;
+		else 
+			thisget = 7;
+		have += thisget;
+		bits -= thisget*3;
+		while (thisget--) {
+			++count[hold&7];
+			hold>>=3;
+		}
+		if (have == ncode)
+			break;
+		hold += ((u32)(*++next)) << bits;
+		bits += 8;
+		hold += ((u32)(*++next)) << bits;
+		bits += 8;
+	}
+	count[0] = 0;
+	if (!ncount[0] && !ncount[1]) return 0; /* if no codes at all, then simply bail, that is invalid */
+
+    /* check for an over-subscribed or incomplete set of lengths */
+	/* this will catch about 319 out of 320 'bad' passwords that */
+	/* have made it into this function. Note, only 1/4 of the    */
+	/* passwords which pass the checksum, can make it here.  Of  */
+	/* those, we drop 319/320 or about that many (a good check!) */
+    left = 1;
+    for (i = 1; i <= 7; ++i) {
+        left <<= 1;
+        left -= count[i];
+        if (left < 0)
+			return 0;	/* over-subscribed */
+    }
+    if (left > 0)
+        return 0;		/* incomplete set */
+
+	return 1;			/* Passed this check! */
 }
 
-static int cmp_exact(char *source, int index)
-{
-	if (salt->flags&1) /* checksum only */
-		return 1;
+//static code const * const lcode = lenfix;
+//static code const * const dcode = distfix;
 
-	/* Do we have ASCII data? */
-	if (salt->flags&2) {
-		if (!salt->ascii_ucmp) {
-			salt->ascii_ucmp_len = salt->asciilen*5;
-			salt->ascii_ucmp = mem_alloc_tiny(salt->ascii_ucmp_len, MEM_ALIGN_NONE);
-			salt->ascii_decr = mem_alloc_tiny(salt->asciilen-12, MEM_ALIGN_NONE);
+#ifdef __GNUC__
+#if __GNUC__ > 3 || (__GNUC__ == 3 && __GNUC_MINOR__ >= 1)
+__attribute__((always_inline))
+#else
+__inline__
+#endif
+#endif
+/* This function handles inflate CODE type 1. This is a 'fixed' table code.  We set the fixed table, */
+/* and then inflate some data (without writing anything.  If we find any BAD lookback data, we can   */
+/* return a failure.  We have 24 bytes of inflate data, and this almost always is more than enough   */
+/* to turn up an error.  If we find we need more, we will do more than 24                            */
+static int check_inflate_CODE1(u8 *next, int left) {
+	u32 whave, op, bits, hold,len;
+	code here;
+
+#if (ARCH_LITTLE_ENDIAN==1) && (ARCH_ALLOWS_UNALIGNED==1)
+	// 'speedup' for x86 type systems.  pkzip/inflate was designed here, so why not use it.
+	hold = *((u32*)next);
+#else
+	hold = *next + (((u32*)next[1])<<8) + (((u32*)next[2])<<16) + (((u32*)next[3])<<24);
+#endif
+	next += 3; // we pre-increment when pulling it in the loop, thus we need to be 1 byte back.
+	left -= 4;
+	hold >>= 3;  // we already processed 3 bits
+	bits = 32-3;
+	for (;;) {
+		if (bits < 15) {
+			if (left < 2)
+				return 1;	// we are out of bytes.  Return we had no error.
+			left -= 2;
+            hold += (u32)(*++next) << bits;
+            bits += 8;
+            hold += (u32)(*++next) << bits;
+            bits += 8;
 		}
-		decrypt(index, salt->asciidat, salt->ascii_decr, salt->asciilen);
-		if (!decomp_validate_ascii(salt->ascii_decr, salt->ascii_ucmp, salt->asciilen-12, salt->ascii_ucmp_len))
+		here=lenfix[hold & 0x1FF];
+        op = (unsigned)(here.bits);
+        hold >>= op;
+        bits -= op;
+        op = (unsigned)(here.op);
+        if (op == 0)							/* literal */
+			++whave;
+        else if (op & 16) {						/* length base */
+            len = (unsigned)(here.val);
+            op &= 15;							/* number of extra bits */
+            if (op) {
+                if (bits < op) {
+					if (!left)
+						return 1;	/*we are out of bytes.  Return we had no error.*/
+					--left;
+                    hold += (u32)(*++next) << bits;
+                    bits += 8;
+                }
+                len += (unsigned)hold & ((1U << op) - 1);
+                hold >>= op;
+                bits -= op;
+            }
+            if (bits < 15) {
+				if (left < 2)
+					return 1;	/*we are out of bytes.  Return we had no error.*/
+				left -= 2;
+                hold += (u32)(*++next) << bits;
+                bits += 8;
+                hold += (u32)(*++next) << bits;
+                bits += 8;
+            }
+            here = distfix[hold & 0x1F];
+          dodist:
+            op = (unsigned)(here.bits);
+            hold >>= op;
+            bits -= op;
+            op = (unsigned)(here.op);
+            if (op & 16) {                      /* distance base */
+                u32 dist = (unsigned)(here.val);
+                op &= 15;                       /* number of extra bits */
+                if (bits < op) {
+					if (!left)
+						return 1;	/*we are out of bytes.  Return we had no error.*/
+					--left;
+                    hold += (u32)(*++next) << bits;
+                    bits += 8;
+                    if (bits < op) {
+						if (!left)
+							return 1;	/*we are out of bytes.  Return we had no error.*/
+						--left;
+                        hold += (u32)(*++next) << bits;
+                        bits += 8;
+                    }
+                }
+                dist += (unsigned)hold & ((1U << op) - 1);
+                if (dist > whave)
+					return 0;  /*invalid distance too far back*/
+                hold >>= op;
+                bits -= op;
+				whave += dist;
+            }
+            else if ((op & 64) == 0) {	/* 2nd level distance code */
+                here = distfix[here.val + (hold & ((1U << op) - 1))];
+                goto dodist;
+            }
+            else
+				return 0;		/*invalid distance code*/
+        }
+		else if (op & 64) {
+			// 2nd level length code.
+            //here = lcode[here.val + (hold & ((1U << op) - 1))];
+            //goto dolen;
+
+			// this causes an infinite loop. Also, I VERY seriously doubt, this will EVER happen in the first
+			// 24 bytes of code.  NOTE, there may be problems, in the fact this causes a inf loop!, but for now,
+			// simply return 0, then debug later.
 			return 0;
+		}
+		else if (op & 32) {
+			// end of block  NOTE, we need to find out if we EVER hit the end of a block, at only 24 bytes??? 
+			// It is VERY likely we do SHOULD NOT EVER hit this. If that is the case, return that this block is bogus.
+			// check next OP (if we have enough bits left), if CODE=3, fail.  If code==0, check
+			return 0;
+		}
+		else {
+			return 0; // invalid literal/length code.
+		}
 	}
-	if (salt->flags&4) {
-		if (!salt->full_encr_dat && salt->filename) {
-			FILE *in = fopen(salt->filename, "rb");
-			salt->full_encr_dat = mem_alloc_tiny(salt->compLen, MEM_ALIGN_NONE);
-			fseek(in, salt->offset, SEEK_SET);
-			if(fread(salt->full_encr_dat, 1, salt->compLen, in) != salt->compLen) {
-				fprintf(stderr, "\nError, can not read the Compressed file from the zipfile.  No additional checking will be performed.\n");
-				return 1;
-			}
-			fclose(in);
+}
+
+/*
+ * Crypt_all simply performs the checksum .zip validatation of the data. It performs
+ * this for ALL hashes provided. If any of them fail to match, then crypt all puts the
+ * complement of the 'proper' checksum of the first hash into the output. These 2 bytes
+ * are checked against the binary for this salt/password combination.  Thus, if any
+ * checksum fails, it will never match binary.  However, if ALL of the checksums match
+ * we then put the checksum bytes from the first hash, into our output data. Then, when
+ * the binary check (cmp_all, cmp_one) is performed, it WILL match.  NOTE, this does
+ * not mean we have found the password.  Just that all hashes quick check checksums
+ * for this password 'work'.
+ */
+static void crypt_all(int _count)
+{
+	int idx;
+#if (ZIP_DEBUG==2)
+	static int CNT, FAILED, FAILED2;
+	++CNT;
+#endif
+
+	// pkzip kinda sucks a little for multi-threading, since there is different amount of work to be
+	// done, depenging upon the password.  Thus, we pack in OMP_MOD passwords into each thread, and
+	// hopefully some of the differnces will even themselves out in the end.  If we have 2 threads
+	// then thread 1 gets 0 to 127 password, and thread 2 gets 128-256.  Once they 'get' their data,
+	// there should be no mutexing of the runtime data, thus the threads should run fast.
+	// Also, since we have 'multiple' files in a .zip file (and multiple checksums), we bail as at the
+	// first time we fail to match checksum.  So, there may be some threads which check more checksums.
+	// Again, hopefully globbing many tests into a threads working set will flatten out these differences.
+#ifdef _OPENMP
+#pragma omp parallel for private(idx)
+#endif
+	for (idx = 0; idx < _count; ++idx) {
+		int cur_hash_count = salt->cnt;
+		int cur_hash_idx = -1;
+		MY_WORD key0, key1, key2;
+		u8 C;
+		const u8 *b;
+		u8 curDecryBuf[256];
+#if USE_PKZIP_MAGIC
+		u8 curInfBuf[128];
+#endif
+		int k, SigChecked;
+		u16 e, v1, v2;
+		z_stream strm;
+		int ret;
+
+		/* use the pwkey for each hash.  We mangle on the 12 bytes of IV to what  was computed in the pwkey load. */
+
+		if (dirty) {
+			u8 *p = (u8*)saved_key[idx];
+
+			/* load the 'pwkey' one time, put it into the K12 array */
+			key0.u = 0x12345678UL; key1.u = 0x23456789UL; key2.u = 0x34567890UL;
+			do {
+				key0.u = pkzip_crc32 (key0.u, *p++);
+				key1.u = (key1.u + key0.c[KB1]) * 134775813 + 1;
+				key2.u = pkzip_crc32 (key2.u, key1.c[KB2]);
+			} while (*p);
+			K12[idx*3] = key0.u, K12[idx*3+1] = key1.u, K12[idx*3+2] = key2.u;
+			goto SkipKeyLoadInit;
 		}
-		if (!salt->full_decr_dat)
-			salt->full_decr_dat = mem_alloc_tiny(salt->compLen-12, MEM_ALIGN_NONE);
-		decrypt(index, salt->full_encr_dat, salt->full_decr_dat, salt->compLen);
-		if (!decomp_validate(salt->full_decr_dat, salt->compLen-12, salt->deCompLen, salt->crc32)) {
-#ifdef ZIP_DEBUG
-			fprintf(stderr, "False positive:  PW found is:  %s\n", saved_key[index]);
+
+		do
+		{
+			// 2nd, and later times through the loop, AND if keys are not dirty (i.e. multiple salts
+			// for the same key load), we do NOT perform the key compute, but instead load the pre-computed
+			// key data from the array.
+			key0.u = K12[idx*3], key1.u = K12[idx*3+1], key2.u = K12[idx*3+2];
+
+SkipKeyLoadInit:;
+			b = salt->H[++cur_hash_idx].h;
+			k=11;
+			e = salt->H[cur_hash_idx].c;
+
+			do
+			{
+				C = PKZ_MULT(*b++,key2);
+				key0.u = pkzip_crc32 (key0.u, C);
+				key1.u = (key1.u + key0.c[KB1]) * 134775813 + 1;
+				key2.u = pkzip_crc32 (key2.u, key1.c[KB2]);
+			}
+			while(--k);
+
+			/* if the hash is a 2 byte checksum type, then check that value first */
+			/* There is no reason to continue if this byte does not check out.  */
+			if (salt->chk_bytes == 2 && C != (e&0xFF))
+				goto Failed_Bailout;
+
+			C = PKZ_MULT(*b++,key2);
+			if (C != (e>>8))
+				goto Failed_Bailout;
+
+			// Now, update the key data (with that last byte.
+			key0.u = pkzip_crc32 (key0.u, C);
+			key1.u = (key1.u + key0.c[KB1]) * 134775813 + 1;
+			key2.u = pkzip_crc32 (key2.u, key1.c[KB2]);
+
+			// Ok, we now have validated this checksum.  We need to 'do some' extra pkzip validation work.
+			// What we do here, is to decrypt a little data (possibly only 1 byte), and perform a single
+			// 'inflate' check (if type is 8).  If type is 0 (stored), and we have a signature check, then
+			// we do that here.  Also, if the inflate code is a 0 (stored block), and we do sig check, then
+			// we can do that WITHOUT having to call inflate.  however, if there IS a sig check, we will have
+			// to call inflate on 'some' data, to get a few bytes (or error code). Also, if this is a type
+			// 2 or 3, then we do the FULL inflate, CRC check here.
+			e = 0;
+
+			// First, we want to get the inflate CODE byte (the first one).
+
+			C = PKZ_MULT(*b++,key2);
+			// Ok, if this is a code 3, we are done.
+			if ( (C & 6) == 6)
+				goto Failed_Bailout;
+			SigChecked = 0;
+			if ( (C & 6) == 0) {
+				// Check that checksum2 is 0 or 1.  If not, I 'think' we can be done
+				if (C > 1)
+					goto Failed_Bailout;
+				// now get 4 bytes.  This is the length.  It is made up of 2 16 bit values.
+				// these 2 values are checksumed, so it is easy to tell if the data is WRONG.
+				// correct data is u16_1 == (u16_2^0xFFFF)
+				curDecryBuf[0] = C;
+				for (e = 0; e <= 4; ) {
+					key0.u = pkzip_crc32 (key0.u, curDecryBuf[e]);
+					key1.u = (key1.u + key0.c[KB1]) * 134775813 + 1;
+					key2.u = pkzip_crc32 (key2.u, key1.c[KB2]);
+					curDecryBuf[++e] = PKZ_MULT(*b++,key2);
+				}
+				v1 = curDecryBuf[1] | (((u16)curDecryBuf[2])<<8);
+				v2 = curDecryBuf[3] | (((u16)curDecryBuf[4])<<8);
+				if (v1 != (v2^0xFFFF))
+					goto Failed_Bailout;
+#if USE_PKZIP_MAGIC
+				// Ok, if we have a signature, check it here, WITHOUT having to call zLib's inflate.
+				if (salt->H[cur_hash_idx].pSig->max_len) {
+					int len = salt->H[cur_hash_idx].pSig->max_len + 5;
+					if (len > salt->H[cur_hash_idx].datlen-12)
+						len = salt->H[cur_hash_idx].datlen-12;
+					SigChecked = 1;
+					for (; e < len;) {
+						key0.u = pkzip_crc32 (key0.u, curDecryBuf[e]);
+						key1.u = (key1.u + key0.c[KB1]) * 134775813 + 1;
+						key2.u = pkzip_crc32 (key2.u, key1.c[KB2]);
+						curDecryBuf[++e] = PKZ_MULT(*b++,key2);
+					}
+
+					if (salt->H[cur_hash_idx].magic == 255) {
+						if (!validate_ascii(&curDecryBuf[5], len-5))
+							goto Failed_Bailout;
+					} else {
+						if (!CheckSigs(&curDecryBuf[5], len-5, salt->H[cur_hash_idx].pSig))
+							goto Failed_Bailout;
+					}
+				}
 #endif
-			return 0;
+			}
+			else {
+				// Ok, now we have handled inflate code type 3 and inflate code 0 (50% of 'random' data)
+				// We now have the 2 'hard' ones left (fixed table, and variable table)
+
+				curDecryBuf[0] = C;
+
+				if ((C&6) == 4) { // inflate 'code' 2  (variable table)
+#if (ZIP_DEBUG==2)
+					static unsigned count, found;
+					++count;
+#endif
+					// we need 4 bytes, + 2, + 4 at most.
+					for (; e < 10;) {
+						key0.u = pkzip_crc32 (key0.u, curDecryBuf[e]);
+						key1.u = (key1.u + key0.c[KB1]) * 134775813 + 1;
+						key2.u = pkzip_crc32 (key2.u, key1.c[KB2]);
+						curDecryBuf[++e] = PKZ_MULT(*b++,key2);
+					}
+					if (!check_inflate_CODE2(curDecryBuf))
+						goto Failed_Bailout;
+#if (ZIP_DEBUG==2)
+					fprintf (stderr, "CODE2 Pass=%s  count = %u, found = %u\n", saved_key[idx], count, ++found);
+#endif
+				}
+				else {
+					int til;
+#if (ZIP_DEBUG==2)
+					static unsigned count, found;
+					++count;
+#endif
+					til = 36;
+					if (salt->H[cur_hash_idx].datlen-12 < til)
+						til = salt->H[cur_hash_idx].datlen-12;
+					for (; e < til;) {
+						key0.u = pkzip_crc32 (key0.u, curDecryBuf[e]);
+						key1.u = (key1.u + key0.c[KB1]) * 134775813 + 1;
+						key2.u = pkzip_crc32 (key2.u, key1.c[KB2]);
+						curDecryBuf[++e] = PKZ_MULT(*b++,key2);
+					}
+					if (!check_inflate_CODE1(curDecryBuf, til))
+						goto Failed_Bailout;
+#if (ZIP_DEBUG==2)
+					fprintf (stderr, "CODE1 Pass=%s  count = %u, found = %u\n", saved_key[idx], count, ++found);
+#endif
+				}
+			}
+#if USE_PKZIP_MAGIC
+			// Ok, now see if we need to check sigs, or do a FULL inflate/crc check.
+			if (!SigChecked && salt->H[cur_hash_idx].pSig->max_len) {
+				int til = 180;
+				if (salt->H[cur_hash_idx].datlen-12 < til)
+					til = salt->H[cur_hash_idx].datlen-12;
+				for (; e < til;) {
+					key0.u = pkzip_crc32 (key0.u, curDecryBuf[e]);
+					key1.u = (key1.u + key0.c[KB1]) * 134775813 + 1;
+					key2.u = pkzip_crc32 (key2.u, key1.c[KB2]);
+					curDecryBuf[++e] = PKZ_MULT(*b++,key2);
+				}
+				strm.zalloc = Z_NULL; strm.zfree = Z_NULL; strm.opaque = Z_NULL; strm.next_in = Z_NULL;
+				strm.avail_in = til;
+		
+				ret = inflateInit2(&strm, -15); /* 'raw', since we do not have gzip header, or gzip crc. .ZIP files are 'raw' implode data. */
+				if (ret != Z_OK)
+				   perror("Error, initializing the libz inflateInit2() system\n");
+
+				strm.next_in = curDecryBuf;
+				strm.avail_out = sizeof(curInfBuf);
+				strm.next_out = curInfBuf;
+
+				ret = inflate(&strm, Z_SYNC_FLUSH);
+
+				inflateEnd(&strm);
+				if (ret != Z_OK)
+					goto Failed_Bailout;
+				if (!strm.total_out)
+					goto Failed_Bailout;
+
+				ret = salt->H[cur_hash_idx].pSig->max_len;
+				if (salt->H[cur_hash_idx].magic == 255) {
+					if (!validate_ascii(curInfBuf, strm.total_out))
+						goto Failed_Bailout;
+				} else {
+					if (strm.total_out < ret)
+						goto Failed_Bailout;
+					if (!CheckSigs(curInfBuf, strm.total_out, salt->H[cur_hash_idx].pSig))
+						goto Failed_Bailout;
+				}
+			}
+#endif
+
+			if (salt->H[cur_hash_idx].full_zip) {
+				u8 inflateBufTmp[1024];
+				if (salt->compLen > 240 && salt->H[cur_hash_idx].datlen >= 200) {
+					for (;e < 200;) {
+						key0.u = pkzip_crc32 (key0.u, curDecryBuf[e]);
+						key1.u = (key1.u + key0.c[KB1]) * 134775813 + 1;
+						key2.u = pkzip_crc32 (key2.u, key1.c[KB2]);
+						curDecryBuf[++e] = PKZ_MULT(*b++,key2);
+					}
+					strm.zalloc = Z_NULL; strm.zfree = Z_NULL; strm.opaque = Z_NULL; strm.next_in = Z_NULL;
+					strm.avail_in = e;
+			
+					ret = inflateInit2(&strm, -15); /* 'raw', since we do not have gzip header, or gzip crc. .ZIP files are 'raw' implode data. */
+					if (ret != Z_OK)
+					   perror("Error, initializing the libz inflateInit2() system\n");
+
+					strm.next_in = curDecryBuf;
+					strm.avail_out = sizeof(inflateBufTmp);
+					strm.next_out = inflateBufTmp;
+
+					ret = inflate(&strm, Z_SYNC_FLUSH);
+					inflateEnd(&strm);
+
+					if (ret != Z_OK) {
+#if (ZIP_DEBUG==2)
+#ifdef _MSC_VER
+						fprintf(stderr, "fail=%d fail2=%d tot=%lld\n", ++FAILED, FAILED2, ((long long)CNT)*_count);
+#else
+						fprintf(stderr, "fail=%d fail2=%d tot=%lld\n", ++FAILED, FAILED2, ((long long)CNT)*_count);
+#endif
+#endif
+						goto Failed_Bailout;
+					}
+				}
+				goto KnownSuccess;
+			}
 		}
-		/* we found the biatch */
-		return 1;
+		while(--cur_hash_count);
+
+		/* We got a checksum HIT!!!! All hash checksums matched. */
+		/* We load the proper checksum value for the gethash */
+KnownSuccess: ;
+		chk[idx] = 1;
+
+		continue;
+		
+Failed_Bailout: ;
+		/* We load the wrong checksum value for the gethash */
+		chk[idx] = 0;
 	}
 
-	return 1;
+	/* clear the 'dirty' flag.  Then on multiple different salt calls, we will not have to */
+	/* encrypt the passwords again. They will have already been loaded in the K12[] array. */
+	dirty = 0;
 }
 
 struct fmt_main fmt_pkzip = {
